(function() {
    var m = {};
    //SDK返回值标准设置
    m.SDK_Success=1;
    m.SDK_Error=-1;
    //服务器请求返回
    m.FW_Success=1;//请求服务成功
    m.FW_Error=-1;//请求服务失败
    m.FW_TiemOut=-2;//登录会话超时，重新登录
    /**
     * 复制对象方法
     */
    m.extend = function(obj, prototypes) {
        for (var key in prototypes) {
            if (prototypes.hasOwnProperty(key)) {
                obj[key] = prototypes[key];
            }
        }
    };
    /**v
     * 判断是否是pc
     */
    m.isPC = function() {
        var userAgentInfo = navigator.userAgent;
        var Agents = ["Android", "iPhone", "SymbianOS", "Windows Phone", "iPad", "iPod"];
        var flag = true;
        if(navigator.platform == "Win32") {
            flag == true;
            return flag;
        }
        for (var v = 0; v < Agents.length; v++) {
            if (userAgentInfo.indexOf(Agents[v]) > 0) {
                flag = Agents[v];
                break;
            }
        }
        return flag;
    };
    /**
     * 初始化方法
     */
    m.ready = function(func) {
        /*if(m.isPC() === true) {
            if(typeof $ != "undefined") {
                $(function() {
                    func()
                });
            } else {
                func();
            }
        } else {
            window.onViewCreate = function() {
                m.appId = md.appId; //应用id
                m.fixStatusBar(document.getElementById("header"));
            }
            window.onViewOpen = function() {
                func();
            };
        }*/
        window.onViewOpen = function() {
                func();
        };
    };

    m.fixStatusBar = function(el) {
        if(!m.isExist(el)) {
            return false;
        }
        var sysType = md.systemType;
        if(sysType == 'ios'){
            el.style.paddingTop = '20px';
        }else if(sysType == 'android' && md.statusBarAppearance == true){
            var ver = md.systemVersion;
            ver = parseFloat(ver);
            if(ver >= 4.4){
                el.style.paddingTop = '25px';
            }
        }
    };

    /**
       * 判断js对象是否存在
       * @method isExist
       * @param  obj 必选 验证的对象
       * @returns {boolean} true/fasle 
       */
     m.isExist=function(obj) {
        return (typeof obj !== 'undefined') && (obj !== null) && (obj !== ''); 
     }; 
    /**
     * json转字符串
     * @method jsonToStr 
     * @param  {object} json 必选 转换的对象
     * @returns {string} 字符串
     */
    m.jsonToStr=function(json) {
        if(typeof json === 'object'){
            return JSON && JSON.stringify(json);
        }
    };
    /**
     * 字符串转json
     * @method strToJson
     * @param  {string} str 必选 转换的字符串
     * @returns {object} json对象
     */
    m.strToJson=function(str){
        if(typeof str === 'string'){
            return JSON && JSON.parse(str);
        }
    };
    /**
     * 是否为数组
     * @method isArray
     * @param  {object} obj 必选 判断的对象
     * @returns {boolean} true/false 是返回true不是返回false 
     */
    m.isArray = function(obj) {
        if(Array.isArray){
            return Array.isArray(obj);
        }else{
            return obj instanceof Array;
        }
    };
    /**
     * 是否为函数
     * @method isFunction
     * @param  {Object} obj 必选 判断的对象
     * @returns {boolean} true/false 是返回true不是返回false 
     */
    m.isFunction = function(obj){
        return Object.prototype.toString.call(obj) === '[object Function]';
    };
    /**
     * 是否为字符串
     * @method isString
     * @param  {Object} obj 必选 判断的对象
     * @returns {boolean} true/false 是返回true不是返回false 
     */
    m.isString = function(obj){
        return Object.prototype.toString.call(obj) === '[object String]';
    };
    /**
     * 过滤字符串，去掉头尾空格
     * @method trim
     * @param  {String} str 必选 字符串
     * @returns {String}  去掉空格的字符串 
     */
     m.trim=function(str) {
        if (String.prototype.trim) {
            return str == null ? "" : String.prototype.trim.call(str);
        } else {
            return str.replace(/(^\s*)|(\s*$)/g, "");
        }
     };
    /**
     * 过滤所有字符串，去掉所有的空格
     * @method trimAll
     * @param  {String} str 必选 字符串
     * @returns {String} 去掉空格的字符串 
     */
     m.trimAll=function(str){
        return str.replace(/\s*/g,'');
     };
    /**
     * 存入本地存储
     * 
     * @method setStorage
     * @param {String} key 必选 键
     * @param {Object} value 必选 值
     */
     m.setStorage=function(key, value) {
        if (window.localStorage) {
            window.localStorage[key] = value;
//          window.localStorage.setItem(key, value);
        } else {
            alert('localStorage null');
        }
    };
    /**
     * 获取本地存储
     * 
     * @method getStorage
     * @required {String} key 必选 键
     * @return {Object} 返回对应的值
     */
    m.getStorage=function(key) {
        if (window.localStorage) {
            return window.localStorage[key];
//          return window.localStorage.getItem(key);
        } else {
            alert('localStorage error');
        }
    };

    /**
       * 清除对应key的本地数据
       * @method  clearStorage
       * @param {String} key 必选 键
       * 
   */
    m.clearStorage = function(key) {
       if(window.localStorage) {
            if(key) {
                window.localStorage.removeItem(key);
            }
        } else {
            alert('localStorage error');
        }
    }
    /**
     * 是否是object对象
     * @method isObject
     * @param  {Object} obj 必选 判断的对象
     * @returns {boolean} true/false 是返回true不是返回false 
     */
    m.isObject = function(obj){
        return Object.prototype.toString.call(obj) === '[object Object]';
    };

    /**
     * 点击事件
     * 
     * @method click
     * @param {string}
     *            selector 必选 选择器(可以是$对象) 
     * @param {function}
     *            func 必须 回调方法， 接收两个参数1：点击当前元素$(this), 2: 点击事件状态e
       * @param {string}
     *            act 可选 点击效果class: md-act1(背景色为#eee)、md-act2(点击缩小弹动效果)
     */
    m.click = function(selector, func, act) {
        var hasTouch = ('ontouchstart' in window);
        var className = act || "";
        var _$target = selector;
        if(m.isString(selector)){
           _$target = $(selector);
        }
        if (className) {
            if (hasTouch) {
                _$target.on("touchstart", function() {
                    $(this).addClass(className);
                });
                _$target.on("touchend", function() {
                    $(this).removeClass(className);
                });
                _$target.on("touchcancel", function() {
                    $(this).removeClass(className);
                });
                _$target.on("touchmove", function() {
                    $(this).removeClass(className);
                });
            } else {
                _$target.on("mousedown", function() {
                    $(this).addClass(className);
                });
                _$target.on("mouseup", function() {
                    $(this).removeClass(className);
                });
            }
        }
        var eventName = "click";
        if(typeof mdui != "undefined" && "ontouchstart" in window) {
            eventName = "touchstart";
        };

        _$target.on(eventName, function(e) {
            var $this = $(this);
            func($this, e);
        });
    };

    /**
     * 打开window窗口
     * @method gotoView
     * @param name      {String} window名字，不能为空字符串
     * @param url       {String} 页面地址，可以为本地文件路径，支持相对路径和绝对路径，以及wgt://、fs://等协议路径，也可以为远程地址
     * @param animation {JSON}  （可选项）动画参数，不传时使用默认动画（从右往左推入），type：窗口动画类型，subType：窗口动画子类型。
     * @param title     {String} win标题栏名称
     * @param hAuto     {boolean}（可选项）是否自适应高度，输入法不挡住输入框
     * @param bounces   {boolean}  可选项 默认值为true, 页面是否弹动 
     * @param framePageData {JSON} 可选项 页面参数，在新页面通过md.pageParam获取
     */
    m.gotoView = function(param) {
        // TODO 待修改
        if(!param.frameUrl) {
            return;
        }
        md.openWin({
            name: param.name,
            url: param.url || "wgt://common/header.html",
            animation:param.animation || { type:"push", subType:"from_right", duration:300},
            pageParam: {
                name: param.name+"_frame",
                frameUrl: param.frameUrl,
                title: param.title,
                hAuto: param.hAuto,
                pageData: param.data || null,
                bounces:param.bounces||false,
                framePageData: param.framePageData,
                reload: true
            },
            reload: true
        });
    };


    /**
     * 没有数据显示显示
     */
    m.noDataPage = function(selector, text) {
        var $n = $(selector);
        if(!$n[0]) {
            $n = $(".md-content");
        }
        if(text == undefined){
            text = "查询无数据";
        }
        var div = '' +
        '<div class="md-box md-ac md-ver md-f1 no-page-content">'+
        '<div class="md-box no-page-img md-img"></div>'+
        '<div class="md-box no-text1">'+text+'</div>'+
        '</div';
        $n.html(div);
        /*$n.tap(function() {
            Base.refreshWin();
        });*/
    };

    /*
    *YHBCP SDK数据请求封装主要
    *@param {String}
    *            businessId 交易编号  
    *@param {String}
    *            data 请求参数对象 必选可为{}，
    *@param {func}
    *            callback 回调方法 可选
    *@param {Boolean}
    *            mask 是否显示蒙层 可选 默认false
    *@param {func}
                 failCallback 失败回调函数
    *@param {Array}
    *            files 上传文件地址 可选
    *
    */
    m.callBusiness = function(businessId,data,callback,mask,failCallback,files) {
        var businessId = businessId||"";
        var data = data||{};
        var mask = mask||false;
        var files = files||[];
        if(!businessId){
            //参数输入有误
            console.log("Base.callBusiness[message]：输入参数有误，请输入正确的交易编号。");
            return;
        }
        //组装通用数据access_token,userid
       /* if (m.isLogin()) {
            data.loginId = md.getPrefs({key: 'username'});
            data.userid = md.getPrefs({key: 'userid'});
            data.userToken = md.getPrefs({key: 'access_token'});
        }*/
        //console.log("data-----"+Base.jsonToStr(data));
        if(mask){
            m.showGifMask("正在加载...");
        }
        
        var xtptParam = {"yad902":businessId,"yad906":data};
        
        if(files.length>0){
            xtptParam["files"] = {files:files}
        }

        console.log("xtptParam"+Base.jsonToStr(xtptParam));
        yhbcp.callBusiness(xtptParam,function(ret){
            if(ret){
                if(ret.yad907==m.SDK_Success){ 
                    //调用公共服务平台成功
                    console.log("Base.callBusiness[message]：调用公共服务平台成功。"+ Base.jsonToStr(ret));
                    var data = ret.yad909;
                    if(data){
                        var code = data.code;
                        if(code == m.FW_Success || ret.yad909.data.respCode=="0"){
                            //数据请求成功
                            if(typeof(callback) == "function"){
                                callback(data);
                            }
                        }else if(code == m.FW_Error){ 
                            //数据请求失败。提示出对应的错误消息
                            var msg = data.msg;
                            //<![CDATA[ 服务不可用！]]>
                            var message = data.message;
                            var msg_data = "";
                            if(msg==undefined&&message){
                                //message有值
                                msg_data = message;
                            }else if(message==undefined&&msg){
                                //msg有值
                                msg_data = msg;
                            }
                            var start = msg_data.indexOf("<![CDATA[");
                            var end = msg_data.lastIndexOf("]]");
                            var errmsg_string = "";
                            if(start>-1&&end>-1){
                                errmsg_string = msg_data.substring(start+9,end);
                            }else{
                                errmsg_string = msg_data;
                            }
                            if(errmsg_string.indexOf("unique") != -1){
                                //重复提交
                                errmsg_string = "请勿重复提交！";
                            }else if(errmsg_string.indexOf("JSONException") != -1){
                                errmsg_string = "登录异常,请稍后重试!";
                            }
                            m.toast(errmsg_string);
                        }else{
                            //调用后台服务接口失败
                            if(typeof(failCallback) == "function"){
                                failCallback(ret);
                            }else{
                                console.log("Base.callBusiness[message]：调用后台服务接口失败。"+ m.jsonToStr(ret));
                            }
                        }//end FW_Success FW_Error else             
                    }else{
                        //调用公共服务平台失败  
                        if(typeof(failCallback) == "function"){
                            failCallback(ret);
                        }else{
                            console.log("Base.callBusiness[message]：调用公共服务平台失败。"+ m.jsonToStr(ret));
                            m.toast(ret.yad908);
                       }
                    }  //end data
                }else{
                    if(typeof(failCallback) == "function"){
                        failCallback(ret);
                    }else{
                        m.toast(ret.yad908);
                        console.log("Base.callBusiness[message]：数据请求异常。"+ m.jsonToStr(ret));
                    }       
                }//end SDK_Success else
            }
            if(mask){
                m.removeGifMask();
            }

        });
    };

    /**
     * 请求服务 特殊接口
     * @method callBusinessOther 
     * @param {String} urlType 根据类型取得服务器地址 必选
     * @param {String} data 请求参数对象  必选可为null， 
     * @param {String} callback 回调方法  可选
     * @param {Boolean} mask 是否显示蒙层 可选 默认false
     * @param {String} type 请求方式:post,get 可选  默认post
     */
    m.callBusinessOther = function (urlType, param, callback, mask, type, nopage) {
        param = param || {};
        if(mask) {
            Base.showGifMask();
        } 
        console.log("--in--:"+ JSON.stringify(param));
        yhbcp.callBusiness({
            yad902: urlType,
            yad906: {input:param}
        },function(ret){
            if(mask) {
                Base.removeGifMask();
            }
           // console.log("+++++查询的结果+++++"+JSON.stringify(ret));
            if(typeof(callback) == "function"){
                callback(ret);
            }
            
        })
    };

    /**
     * 请求服务 调用劳动关系的存储过程(<input><inputxml><row></row></inputxml><input>)
     * @method callBusinessOther 
     * @param {String} urlType 根据类型取得服务器地址 必选
     * @param {String} data 请求参数对象  必选可为null， 
     * @param {String} callback 回调方法  可选
     * @param {Boolean} mask 是否显示蒙层 可选 默认false
     * @param {String} type 请求方式:post,get 可选  默认post
     */
    m.callBusinessPkg = function(urlType, param, callback, mask, type, nopage){
         param = param || {};
        if(mask) {
            Base.showGifMask();
        } 
        var row ={};
        row.row = param;
        var inputxml = {};
        inputxml.inputxml=row;
        console.log("--in--:"+ JSON.stringify(param));
        yhbcp.callBusiness({
            yad902: urlType,
            yad906: {input:inputxml}
        },function(ret){
            if(mask) {
                Base.removeGifMask();
            }
           // console.log("+++++查询的结果+++++"+JSON.stringify(ret));
            if(typeof(callback) == "function"){
                callback(ret);
            }
            
        })
    };



    /*
     *判断是否登录
     *@return boolean true已登录false未登录
     */
    m.isLogin=function(){
        var token = md.getPrefs({key: 'loginUser'});
        if(token){
            return true;
        }
        return false;
    };

    /*
     *获取登录用户信息
     *@return Object 用户对象
     */
    m.getUserInfo=function(){
        var loginUser = md.getPrefs({
                            key: 'loginUser'
                        });
        return m.strToJson(loginUser);
    };

    /**
     * 显示gifMask
     * 
     * @method showGifMask
     */
    m.showGifMask = function(text) {
            md.showProgress({
                content: text,
                modal: false
            });
    };
    /**
     * 移除gifMask（与showGifMask相对应）
     * 
     * @method removeGifMask
     */
    m.removeGifMask = function() {
            md.hideProgress();
    };

    /**
     * 信息提示()
     * 
     * @method toast
     * @param {string}
     *            msg 必选 提示信息
     * @param {string}
     *            time 可选 持续时长，单位：毫秒
     * @param {string}
     *            location 可选 弹出位置，顶部、中间或底部（top-顶部/middle-中间/bottom-底部
     */
    m.toast = function(msg, time, location) {
        var time = time || 2000;
        if(time<1000){
            time = 1000;
        }
        time = time - 1000;
        var location = location || "middle";

        var $body = $("body");
        if($body.children(".md-msgtip").length>0){
            $body.children(".md-msgtip").remove();
        }

        var $msgTip = $("<div class='md-msgtip'>"+
                            "<div class='md-msgtip-img'></div>"+
                            "<div class='md-msgtip-text'>"+msg+"</div>"+
                        "</div>");
        $body.append($msgTip);

        //2设置提示框的样式
        var _bodyW = $(window).width();
        var _bodyH = $(window).height();
        var _msgTipW = $msgTip.width();
        var _msgTipH = $msgTip.height();

        var cssStyle = {};
        //2.1 横向居中
        cssStyle.left = (_bodyW-_msgTipW)/2;
        //2.2 判断位置
        if(location=="middle"){
            cssStyle.top = (_bodyH-_msgTipH)/2;
        }else if(location=="top"){
            cssStyle.top = 0;
        }else if(location=="bottom"){
            cssStyle.top = _bodyH-_msgTipH;
        }
        $msgTip.css(cssStyle);
        //3淡入
        $msgTip.fadeIn(500,1,function(){
            window.setTimeout(function() {
                $msgTip.fadeOut(500,0,function(){
                    $msgTip.remove();
                });        
            }, time);
        });
    };


    /**
     * 根据元素打开窗口
     * @method openFrameByEle
     * @param  {string} id 必选 id
     * @param {json} param 必选 json对象
     * @param {string} param.name 必选 frame名字
     * @param {string} param.url 必选 页面地址，可以为本地文件路径，支持相对路径和绝对路径，以及wgt://、fs://等协议路径，也可以为远程地址
     * @param {json} param.pageParam 可选项 页面参数，在新页面通过md.pageParam获取
     * @param {boolean} param.bounces 可选项 默认值为true, 页面是否弹动 
     * @param {boolean} param.bgColor （可选项）背景色，支持图片和颜色，格式为#ffffff，图片路径支持fs://、wgt://等MDLIFE自定义文件路径协议，如果设置为'transparent'，则不论config.json里是否配置了frameBackground都将会把背景设置为透明。
     * @param {boolean} param.vScrollBarEnabled （可选项）是否显示垂直滚动条 默认值：true，若在config.json里面配置了frame的vScrollBarEnabled，则默认值为配置的值。
     * @param {boolean} param.hScrollBarEnabled（可选项）是否显示水平滚动条 默认值：false，
     * @param {boolean} param.hAuto（可选项）是否自适应高度，输入法不挡住输入框
     * @param {string} param.reload （可选项）页面已经打开时，是否重新加载页面 默认值：false
     * @param {Object} param.margin (可选项) 设置margin后，在不同手机上面会保持与父页面的各方向边距一致，而中间区域会自动扩充
     */
    m.openFrameByEle = function(id, param) {
        var obj = document.getElementById(id);
        var x = obj.offsetLeft || 0;
        var y = obj.offsetTop || 0;
        var w = obj.offsetWidth || 320;
        var h = obj.offsetHeight || 480;
         if(param.bounces == undefined) {
           param.bounces = true; 
        }
        if(param.vScrollBarEnabled == undefined) {
           param.vScrollBarEnabled = false; 
        }
        if(param.hScrollBarEnabled == undefined) {
           param.hScrollBarEnabled = false; 
        }
        var rect;
        if(param.margin){
            rect = param.margin;
            /*rect = {            
                marginLeft: '0',
                marginTop: '0',
                marginBottom: param.marginBottom,
                marginRight: '0'
            };*/
        }else{
            rect = {
                x: x,
                y: y,
                w: w,
                h: h
            };
        }
        
        if(param.hAuto === true || param.hAuto === "1") {
            delete rect.h;
        } 

        if(param.bounces==="1"){
            param.bounces = true;
        }else if(param.bounces==="0"){
            param.bounces = false;
        }
        if(param.reload==="1"){
            param.reload = true;
        }else if(param.reload==="0"){
            param.reload = false;
        }

        md.openFrame({
            name: param.name,
            url: param.url,
            rect: rect,
            pageParam: param.pageParam,
            bounces: param.bounces,
            bgColor: param.bgColor || "#ffffff",
            vScrollBarEnabled: param.vScrollBarEnabled,
            hScrollBarEnabled: param.hScrollBarEnabled,
            reload: param.reload
        });
    };

    /**
     * 根据相对路径获取绝对路径
     * 
     * @method getRealPath
     * @param {string}
     *            url 路径
     */
    m.getRealPath=function(url){
        var realPath;
        if (url.indexOf("http://") != -1) {
            realPath = url;
        } else {
            realPath = "wgt://" + url;
            realPath = md.getSchemeURLRealPath({
                            url:realPath
                        });
            realPath = realPath.replace("wgt://", "");
        }

        return realPath;
    };

    if(typeof Base == "undefined") {
        window.Base = m;
    } else {
        m.extend(Base, m);
    }
    
    
})();