(function($){
	$.extend($.fn,{   
        //获取当前样式
        _getTargetStyle:function(attr){
            var _$target = this.get(0);
            //特性侦测
            if(window.getComputedStyle){
                //优先使用W3C规范
                return parseFloat(parseFloat(window.getComputedStyle(_$target)[attr]).toFixed(2));
            }else{
                //针对IE9以下兼容
                return parseFloat(parseFloat(_$target.currentStyle[attr]).toFixed(2));
            }
        } ,
		/*
         *@desc 获取目标元素的width(四舍五入保留两位小数)
         *return float 传入对象的width
         */
	    getTargetWidth:function() {            
            var _width = this._getTargetStyle("width");
            return _width;          
	    },
	    /*
         *@desc 获取目标元素的width+padding(四舍五入保留两位小数)
         *return float 传入对象的width+padding
         */
	    getTargetInnerWidth:function() {   
	    	var _width = this.getTargetWidth();
            var _paddingRight = this._getTargetStyle("padding-right");
            var _paddingLeft = this._getTargetStyle("padding-left");
            return (_width+_paddingRight+_paddingLeft);    
	    },
	    /*
         *@desc 获取目标元素的width+padding+border+[margin](四舍五入保留两位小数)
         *@param isGetMargin 是否获取margin true是，false否
         *return float 传入对象的width+padding+border+[margin]
         */
	    getTargetOuterWidth:function(isGetMargin) {   
            var _isGetMargin = isGetMargin || false;

            var _wp = this.getTargetInnerWidth();
            var _borderRight = this._getTargetStyle("border-right-width");
            var _borderLeft = this._getTargetStyle("border-left-width");
            if(_isGetMargin){
                var _marginRight = this._getTargetStyle("margin-right");
                var _marginLeft = this._getTargetStyle("margin-left");
                return (_wp+_marginRight+_marginLeft+_borderRight+_borderLeft);
            }
            return (_wp+_borderRight+_borderLeft);       
	    },
        /*
         *@desc 获取目标元素左边的padding-left+border-left-width+[margin-left](四舍五入保留两位小数)
         *@param isGetMargin 是否获取margin true是，false否
         *return float 传入对象的padding-left+border-left-width+[margin-left]
         */
        getTargetLeftWidth:function(isGetMargin){
            var _isGetMargin = isGetMargin || false;
            var _paddingLeft = this._getTargetStyle("padding-left");
            var _borderLeft = this._getTargetStyle("border-left-width");
            if(_isGetMargin){
                var _marginLeft = this._getTargetStyle("margin-left");
                return (_paddingLeft+_marginLeft+_borderLeft);
            }else{
                return (_paddingLeft+_borderLeft);
            }

        },
        /*
         *@desc 获取目标元素右边的padding-right+border-right-width+[margin-right](四舍五入保留两位小数)
         *@param isGetMargin 是否获取margin true是，false否
         *return float 传入对象的padding-right+border-right-width+[margin-right]
         */
        getTargetRightWidth:function(isGetMargin){
            var _isGetMargin = isGetMargin || false;
            var _$target = this.get(0); 
            var _paddingRight = this._getTargetStyle("padding-right");
            var _borderRight = this._getTargetStyle("border-right-width");
            if(_isGetMargin){
                var _marginRight = this._getTargetStyle("margin-right");
                return (_paddingRight+_marginRight+_borderRight);
            }else{
                return (_paddingRight+_borderRight);
            }

        },
	    /*
         *@desc 获取目标元素的height(四舍五入保留两位小数)
         *return float 传入对象的height
         */
	    getTargetHeight:function() {                 
            var _height = this._getTargetStyle("height");
            return _height;
	    },
	    /*
         *@desc 获取目标元素的height+padding(四舍五入保留两位小数)
         *return float 传入对象的height+padding
         */
	    getTargetInnerHeight:function() {   
            var _height = this.getTargetHeight();
            var _paddingTop = this._getTargetStyle("padding-top");
            var _paddingBottom = this._getTargetStyle("padding-bottom");
            return (_height+_paddingTop+_paddingBottom);      
	    },
	    /*
         *@desc 获取目标元素的height+padding+border+[margin](四舍五入保留两位小数)
         *@param isGetMargin 是否获取margin true是，false否
         *return float 传入对象的height+padding+border+[margin]
         */
	    getTargetOuterHeight:function(isGetMargin) {   
            var _isGetMargin = isGetMargin || false;
            var _hp = this.getTargetInnerHeight();
            var _borderTop = this._getTargetStyle("border-top-width");
            var _borderBottom = this._getTargetStyle("border-bottom-width");
            if(_isGetMargin){
                var _marginTop = this._getTargetStyle("margin-top");
                var _marginBottom = this._getTargetStyle("margin-bottom");
                return (_hp+_marginTop+_marginBottom+_borderTop+_borderBottom);
            }
            return (_hp+_borderTop+_borderBottom);
	    },
        /*
         *@desc 获取目标元素的padding-top+border-top-width+[margin-top](四舍五入保留两位小数)
         *@param isGetMargin 是否获取margin true是，false否
         *return float 传入对象的padding-top+border-top-width+[margin-top]
         */
        getTargetTopHeight:function(isGetMargin){
            var _isGetMargin = isGetMargin || false;
            var _paddingTop = this._getTargetStyle("padding-top");
            var _borderTop = this._getTargetStyle("border-top-width");
            if(_isGetMargin){
                var _marginTop = this._getTargetStyle("margin-top");
                return (_paddingTop+_marginTop+_borderTop);
            }else{
                return (_paddingTop+_borderTop);
            }

        },
        /*
         *@desc 获取目标元素的padding-bottom+border-bottom-width+[margin-bottom](四舍五入保留两位小数)
         *@param isGetMargin 是否获取margin true是，false否
         *return float 传入对象的padding-bottom+border-bottom-width+[margin-bottom]
         */
        getTargetBottomHeight:function(isGetMargin){
            var _isGetMargin = isGetMargin || false;
            var _paddingBottom = this._getTargetStyle("padding-bottom");
            var _borderBottom = this._getTargetStyle("border-bottom-width");
            if(_isGetMargin){
                var _marginBottom = this._getTargetStyle("margin-bottom");
                return (_paddingBottom+_marginBottom+_borderBottom);
            }else{
                return (_paddingBottom+_borderBottom);
            }
        },

        /*
         *@desc 淡入
         *@param time          {Number}  淡入时间，单位毫秒
         *@param targetOpacity {Number}  目标透明度，取值范围(0-1)
         *@param func          {function}回调函数
         */
        fadeIn:function(time,targetOpacity,func){  
            var _self = this;
            var opacity = targetOpacity || 1;
            var time = time || 500;
            var oldOpacity = _self.css("opacity");
            if(oldOpacity===""){
                oldOpacity = 0;
            }

            if(oldOpacity>opacity){
                return;
            }
            //次数
            var num = Math.ceil((opacity - oldOpacity)/0.01);
            //间隔时间
            var numTime = time/num;
            var t = setInterval(function(){  
                var _nowOpacity = _self.css("opacity");
                if(_nowOpacity < opacity){  
                   _self.css("opacity",parseFloat(_nowOpacity)+0.01);  
                }else{  
                    clearInterval(t); 
                    if(typeof(func) == "function"){
                        func();
                    } 
                }  
            },numTime);  
        },
        /*
         *@desc 淡出
         *@param time          {Number}  淡出时间，单位毫秒
         *@param targetOpacity {Number}  目标透明度，取值范围(0-1)
         *@param func          {function}回调函数
         */
        fadeOut:function(time,targetOpacity,func){  
            var _self = this;
            var opacity = targetOpacity || 0;
            var time = time || 500;
            var oldOpacity = _self.css("opacity");
            if(oldOpacity===""){
                oldOpacity = 1;
            }

            if(oldOpacity<opacity){
                return;
            }
            
            //次数
            var num = Math.ceil((oldOpacity - opacity)/0.01);
            //间隔时间
            var numTime = time/num;
            var t = setInterval(function(){  
                var _nowOpacity = _self.css("opacity");
                if(_nowOpacity > opacity){  
                   _self.css("opacity",parseFloat(_nowOpacity)-0.01);  
                }else{  
                    clearInterval(t);  
                    if(typeof(func) == "function"){
                        func();
                    } 
                }  
            },numTime);   
        },

        /*
         *计算元素内文本行数
         */
        countLines:function() {
            var lh = parseInt(this._getTargetStyle("line-height"), 10);
            var h = parseInt(this._getTargetStyle("height"), 10);
            var lc = Math.round(h / lh);
            return lc;
        }

	});       
})(Zepto)